"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const docker_command_1 = __importDefault(require("../../docker-command"));
class Status extends docker_command_1.default {
    run() {
        return __awaiter(this, void 0, void 0, function* () {
            const { flags } = this.parse(Status);
            this.spinner.start('Engine is');
            const services = yield this.listServices({ name: flags.name });
            if (services.length === 0) {
                this.spinner.stop('stopped');
                return 1 /* STOPPED */;
            }
            this.spinner.stop('started');
            return 0 /* STARTED */;
        });
    }
}
exports.default = Status;
Status.description = 'Get the Engine\'s status';
Status.flags = Object.assign({}, docker_command_1.default.flags);
