"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const base58 = __importStar(require("@mesg/api/lib/util/base58"));
const root_command_1 = __importDefault(require("../../root-command"));
class ProcessCreate extends root_command_1.default {
    run() {
        return __awaiter(this, void 0, void 0, function* () {
            const { args } = this.parse(ProcessCreate);
            this.spinner.start('Create process');
            const definition = JSON.parse(args.DEFINITION, function (key, value) {
                return key && key.match(/hash$/i) && value && typeof value === 'string'
                    ? base58.decode(value)
                    : value;
            });
            const resp = yield this.api.process.create(definition);
            if (!resp.hash) {
                throw new Error('invalid response');
            }
            this.spinner.stop(base58.encode(resp.hash));
            return resp;
        });
    }
}
exports.default = ProcessCreate;
ProcessCreate.description = 'Create a process';
ProcessCreate.flags = Object.assign({}, root_command_1.default.flags);
ProcessCreate.args = [{
        name: 'DEFINITION',
        required: true,
        description: 'Process\'s definition. Use process:compile first to build process definition'
    }];
