"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const command_1 = require("@oclif/command");
const base58 = __importStar(require("@mesg/api/lib/util/base58"));
const root_command_1 = __importDefault(require("../../root-command"));
const resolver_1 = require("../../utils/resolver");
class ServiceStart extends root_command_1.default {
    run() {
        return __awaiter(this, void 0, void 0, function* () {
            const { args, flags } = this.parse(ServiceStart);
            this.spinner.start('Starting runner');
            const serviceHash = yield resolver_1.serviceResolver(this.api, args.SERVICE_HASH);
            const { hash } = yield this.api.runner.create({
                serviceHash,
                env: flags.env
            });
            if (!hash)
                throw new Error('invalid runner');
            this.spinner.stop(base58.encode(hash));
            const runner = yield this.api.runner.get({ hash });
            this.log(`Runner started with hash ${base58.encode(hash)} and instance hash ${base58.encode(runner.instanceHash)}`);
            return { hash };
        });
    }
}
exports.default = ServiceStart;
ServiceStart.description = 'Start a service by creating a new runner';
ServiceStart.flags = Object.assign(Object.assign({}, root_command_1.default.flags), { env: command_1.flags.string({
        description: 'Set environment variables',
        multiple: true,
        helpValue: 'FOO=BAR'
    }) });
ServiceStart.args = [{
        name: 'SERVICE_HASH',
        required: true,
    }];
