import { flags } from '@oclif/command';
import { Network } from 'node-docker-api/lib/network';
import Command from './root-command';
interface Event {
    Type: string;
    Action: string;
    from: string;
}
interface NetworkOption {
    name: string;
}
interface ListOption {
    name: string;
}
interface ServiceOption {
    name: string;
    version: string;
    port: number;
    path: string;
    p2pPort: number;
}
export default abstract class extends Command {
    static flags: {
        name: flags.IOptionFlag<string>;
        help: import("@oclif/parser/lib/flags").IBooleanFlag<void>;
        quiet: import("@oclif/parser/lib/flags").IBooleanFlag<boolean>;
        silent: import("@oclif/parser/lib/flags").IBooleanFlag<boolean>;
        port: import("@oclif/parser/lib/flags").IOptionFlag<number>;
        host: flags.IOptionFlag<string>;
    };
    private readonly docker;
    listServices(options: ListOption): Promise<import("node-docker-api/lib/service").Service[]>;
    waitForEvent(matchFilter: (event: Event) => boolean): Promise<unknown>;
    getOrCreateNetwork(options: NetworkOption): Promise<Network>;
    createEngineService(network: Network, options: ServiceOption): Promise<import("node-docker-api/lib/service").Service>;
    pull(tag: string): Promise<object>;
}
export {};
