import { Command, flags } from '@oclif/command';
import { IConfig } from '@oclif/config';
import API from '@mesg/api';
import { hash } from '@mesg/api/lib/types';
export default abstract class extends Command {
    static flags: {
        help: import("@oclif/parser/lib/flags").IBooleanFlag<void>;
        quiet: import("@oclif/parser/lib/flags").IBooleanFlag<boolean>;
        silent: import("@oclif/parser/lib/flags").IBooleanFlag<boolean>;
        port: import("@oclif/parser/lib/flags").IOptionFlag<number>;
        host: flags.IOptionFlag<string>;
    };
    api: API;
    private readonly _app;
    constructor(argv: string[], config: IConfig);
    get spinner(): import("cli-ux").ActionBase | {
        start: () => void;
        stop: (message?: string) => void;
        status: any;
    };
    flagsAsArgs({ port, host }: any): string[];
    log(message?: string, ...args: any[]): void;
    styledJSON(data: any): void;
    catch(err: Error): Promise<void>;
    execute(request: {
        executorHash: hash;
        taskKey: string;
        eventHash: hash;
        inputs?: {
            [key: string]: any;
        };
        tags?: string[];
    }): Promise<{
        [key: string]: any;
    }>;
}
