"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const base58 = __importStar(require("@mesg/api/lib/util/base58"));
// TODO: all the following should be replaced by grpc error code
class IsAlreadyExistsError extends Error {
    constructor(error) {
        super(error.message);
        const res = IsAlreadyExistsError.regexp.exec(error.message);
        const hash = res && res.length >= 1 ? res[1] : '';
        this.hash = base58.decode(hash);
        this.name = IsAlreadyExistsError.ID;
    }
    static match(err) {
        return IsAlreadyExistsError.regexp.test(err.message);
    }
}
exports.IsAlreadyExistsError = IsAlreadyExistsError;
IsAlreadyExistsError.ID = 'ALREADY_EXISTS';
IsAlreadyExistsError.regexp = new RegExp('\"(.*)\" already exists');
